/*===============================================================================================================================================*/
// ************************************************** THESE ARE THE INFORMATIONS OF THE MAP: *************************************************** //
/*===============================================================================================================================================*/
// NONE FOR NOW:
/*-----------------------------------------------------------------------------------------------------------------------------------------------*/

// THE YOKOHAMA CONQUEST:
// CREATED BY DANY:
// MARCH 2008:

/*===============================================================================================================================================*/
// *************************************************** MAIN ENTRY POINT FOR RANDOM MAP SCRIPT: ************************************************* //
/*===============================================================================================================================================*/
// NONE FOR NOW:
/*-----------------------------------------------------------------------------------------------------------------------------------------------*/

include "mercenaries.xs";
include "ypAsianInclude.xs";
include "ypKOTHInclude.xs";

void main(void)
{

/*===============================================================================================================================================*/
// ****************************************************** INITIALIZE MAP TYPE VARIABLES: ******************************************************* //
/*===============================================================================================================================================*/
// NONE FOR NOW:
/*-----------------------------------------------------------------------------------------------------------------------------------------------*/

        string nativeCiv1 = "";
        string nativeCiv2 = "";
 
        string baseMix = "coastal_japan_b";
        string baseTerrain = "water";
        string seaType = "Coastal Japan";
        string cliffType = "Coastal Japan";
 
        string forestType = "Coastal Japan Forest";
        string startTreeType = "ypTreeJapaneseMaple";
  
        string baseIslandTerrain = "coastal_japan_c";
        string islandTerrain = "coastal_japan_b";
        string mapType1 = "Japan";
  
        string huntable1 = "ypSerow";
        string huntable2 = "ypGiantSalamander";
        string fish1 = "ypFishCatfish";
        string fish2 = "ypSquid";
        string whale1 = "HumpbackWhale";
  
        string patchMix = "coastal_japan_forest";
        string patchTerrain = "coastal_japan\ground_grass3_co_japan";
        string patchType1 = "coastal_japan\ground_grass2_co_japan";
        string patchType2 = "coastal_japan\ground_grass1_co_japan";
  
        string lightingType = "Honshu";

/*===============================================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.01);
/*===============================================================================================================================================*/
// ************************************************ CHOOSES WHICH NATIVES APPEAR ON THE MAP: *************************************************** //
/*===============================================================================================================================================*/
// NONE FOR NOW:
/*-----------------------------------------------------------------------------------------------------------------------------------------------*/
	
	    int subCiv0=-1;
        int subCiv1=-1;
		int subCiv2=-1;
        int subCiv3=-1;
		int subCiv4=-1;
        int subCiv5=-1;
		
/*===============================================================================================================================================*/
// NONE FOR NOW:
/*-----------------------------------------------------------------------------------------------------------------------------------------------*/

        if (rmAllocateSubCivs(6) == true)
	{
		subCiv0=rmGetCivID("zen");
		rmEchoInfo("subCiv0 is zen "+subCiv0);
		if (subCiv0 >= 0)
		rmSetSubCiv(0, "zen");

		subCiv1=rmGetCivID("jesuit");
		rmEchoInfo("subCiv1 is jesuit "+subCiv1);
		if (subCiv1 >= 0)
		rmSetSubCiv(1, "jesuit");
		
		subCiv2=rmGetCivID("zen");
		rmEchoInfo("subCiv2 is zen "+subCiv2);
		if (subCiv2 >= 0)
		rmSetSubCiv(2, "zen");

		subCiv3=rmGetCivID("jesuit");
		rmEchoInfo("subCiv3 is jesuit "+subCiv3);
		if (subCiv3 >= 0)
		rmSetSubCiv(3, "jesuit");
		
		subCiv4=rmGetCivID("zen");
		rmEchoInfo("subCiv4 is zen "+subCiv4);
		if (subCiv4 >= 0)
		rmSetSubCiv(4, "zen");

		subCiv5=rmGetCivID("jesuit");
		rmEchoInfo("subCiv5 is jesuit "+subCiv5);
		if (subCiv5 >= 0)
		rmSetSubCiv(5, "jesuit");
	}

/*===============================================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.05);
/*===============================================================================================================================================*/
// ********************************************************* PICKS THE MAP SIZE: *************************************************************** //
/*===============================================================================================================================================*/
// NONE FOR NOW:
/*-----------------------------------------------------------------------------------------------------------------------------------------------*/
	
	    int playerTiles=40000;
	    
		int size=2.0*sqrt(cNumberNonGaiaPlayers*playerTiles);
	    rmEchoInfo("Map size="+size+"m x "+size+"m");
	    rmSetMapSize(800, 800); // THE NUMBER 800 IS REPLACING THE WORD: "size":
	
/*===============================================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.10);
/*===============================================================================================================================================*/
// ******************************************************** DEFINE THE MAP PARAMETERS: ********************************************************* //	
/*===============================================================================================================================================*/
// NONE FOR NOW:
/*-----------------------------------------------------------------------------------------------------------------------------------------------*/
        
	    // SET UP DEFAULT WATER TYPE:
	    
		// SET SEA LEVEL:
		rmSetSeaLevel(1.0);          
	    
		// SET SEA TYPE:
		// rmSetSeaType(seaType);
		   rmSetSeaType("Coastal Japan");
        
		// ENABLE LOCAL WATER:
		rmEnableLocalWater(false);
	    
		// SET BASE TERRAIN MIX:
		// rmSetBaseTerrainMix(baseMix);
		   rmSetBaseTerrainMix("coastal_japan_b");
	    
		// SET MAP TYPE:
		// rmSetMapType(mapType1);
		   rmSetMapType("Japan");
	    rmSetMapType("grass");
	    rmSetMapType("water");
	    
		// SET LIGHTING:
		// rmSetLightingSet(lightingType);
		   rmSetLightingSet("Honshu");

	    // INITIALIZE MAP:
	    // rmTerrainInitialize(baseTerrain);
		   // rmTerrainInitialize("water");
		      rmTerrainInitialize("yukon\ground1_yuk", 4);
	    
		// CHOOSE MERCS:
		chooseMercs();

/*===============================================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.15);
/*===============================================================================================================================================*/
// **************************************** DEFINE SOME CLASSES: THESE ARE USED LATER FOR CONSTRAINTS: ***************************************** //
/*===============================================================================================================================================*/
// NONE FOR NOW:
/*-----------------------------------------------------------------------------------------------------------------------------------------------*/
	
	    int classPlayer=rmDefineClass("player");
	  
/*===============================================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.20);
/*===============================================================================================================================================*/
// ********************************************************* DEFINE THE CONSTRAINTS: *********************************************************** //
// **************************************** THESE ARE USED TO HAVE OBJECTS AND AREAS AVOID EACH OTHER: ***************************************** //
/*===============================================================================================================================================*/
// NONE FOR NOW:
/*-----------------------------------------------------------------------------------------------------------------------------------------------*/
   
    // MAP EDGE CONSTRAINTS:
    //int playerEdgeConstraint=rmCreateBoxConstraint("player edge of map", rmXTilesToFraction(6), rmZTilesToFraction(6), 1.0-rmXTilesToFraction(6), 1.0-rmZTilesToFraction(6), 0.01);
	int playerEdgeConstraint=rmCreatePieConstraint("player edge of map", 0.5, 0.5, rmXFractionToMeters(0.0), rmXFractionToMeters(0.475), rmDegreesToRadians(0), rmDegreesToRadians(360));
	int playerCloseEdgeConstraint=rmCreatePieConstraint("close edge of map", 0.5, 0.5, rmXFractionToMeters(0.0), rmXFractionToMeters(0.485), rmDegreesToRadians(0), rmDegreesToRadians(360));
	
	int coinEdgeConstraint=rmCreateBoxConstraint("coin edge of map", rmXTilesToFraction(19), rmZTilesToFraction(19), 1.0-rmXTilesToFraction(19), 1.0-rmZTilesToFraction(19), 2.0);
	int coinEdgeWestConstraint=rmCreateBoxConstraint("coin edge of mapwest", rmXTilesToFraction(19), rmZTilesToFraction(19), 1.0-rmXTilesToFraction(19), 1.0-rmZTilesToFraction(19), 2.0);

    // CREATE THE CARDINAL DIRECTION CONSTRAINTS:
    int Northward=rmCreatePieConstraint("northMapConstraint", 0.50, 0.50, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(315), rmDegreesToRadians(135));
    int Southward=rmCreatePieConstraint("southMapConstraint", 0.50, 0.50, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(135), rmDegreesToRadians(315));
    int Eastward=rmCreatePieConstraint("eastMapConstraint", 0.50, 0.50, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(45), rmDegreesToRadians(225));
    int Westward=rmCreatePieConstraint("westMapConstraint", 0.50, 0.50, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(225), rmDegreesToRadians(45));
	
	// PLAYER CONSTRAINTS:
	int playerConstraint=rmCreateClassDistanceConstraint("stay away from players", classPlayer, 20.0);
	int longPlayerConstraint=rmCreateClassDistanceConstraint("stay far away from players", classPlayer, 50.0);
   	
	// COIN AVOIDANCE:
	int avoidCoin=rmCreateTypeDistanceConstraint("avoid coin", "gold", 35.0);
	int avoidCoinFar=rmCreateTypeDistanceConstraint("avoid coin far", "gold", 60.0);
   
    // AVOID IMPASSABLE LAND:
	int avoidImpassableLand=rmCreateTerrainDistanceConstraint("stuff vs impassable land", "Land", false, 10.0);
	int avoidCloseImpassableLand=rmCreateTerrainDistanceConstraint("close vs impassable land", "Land", false, 5.0);
	int shortAvoidImpassableLand=rmCreateTerrainDistanceConstraint("short avoid impassable land", "Land", false, 2.0);
	int mediumAvoidImpassableLand=rmCreateTerrainDistanceConstraint("medium avoid impassable land", "Land", false, 12.0);
	int longAvoidImpassableLand=rmCreateTerrainDistanceConstraint("long avoid impassable land", "Land", false, 20.0);
   
	// CONSTRAINT TO AVOID WATER:
	int avoidWater4 = rmCreateTerrainDistanceConstraint("avoid water short 4", "Land", false, 4.0);
	int avoidWater6 = rmCreateTerrainDistanceConstraint("avoid water short 6", "Land", false, 6.0);
    int avoidWater8 = rmCreateTerrainDistanceConstraint("avoid water short 8", "Land", false, 8.0);
	int avoidWater12 = rmCreateTerrainDistanceConstraint("avoid water medium 12", "Land", false, 12.0);
    int avoidWater16 = rmCreateTerrainDistanceConstraint("avoid water medium 16", "Land", false, 16.0);
	int avoidWater20 = rmCreateTerrainDistanceConstraint("avoid water long 20", "Land", false, 20.0);
	int avoidWater24 = rmCreateTerrainDistanceConstraint("avoid water long 24", "Land", false, 8.0);
	
    // DECORATION AVOIDANCE: ( DECORATION = OBJECTS...MAYBE: )
    int avoidAll=rmCreateTypeDistanceConstraint("avoid all", "all", 8.0);

    // CREATE THE NATIVES CLASS:
	int classNatives=rmDefineClass("natives");
    
	// CREATE THE NATIVES CONSTRAINTS:
	int nativesConstraint=rmCreateClassDistanceConstraint("stuff avoids natives", rmClassID("natives"), 15.0);
    int nativesMediumConstraint=rmCreateClassDistanceConstraint("medium vs natives", rmClassID("natives"), 35.0);
	int nativesFarConstraint=rmCreateClassDistanceConstraint("far vs natives", rmClassID("natives"), 65.0);
	
	// CREATE THE IMPORTANT ITEM CLASS:
	int importantItemClass=rmDefineClass("importantItem");
	
	// CREATE THE IMPORTANT ITEM CONSTRAINTS:
	int importantItemConstraint=rmCreateClassDistanceConstraint("stuff vs importantItem", rmClassID("importantItem"), 15.0);
    int importantMediumItemConstraint=rmCreateClassDistanceConstraint("medium vs importantItem", rmClassID("importantItem"), 35.0);
    int importantFarItemConstraint=rmCreateClassDistanceConstraint("far vs importantItem", rmClassID("importantItem"), 65.0);	
	
/*===============================================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.30);
/*===============================================================================================================================================*/
// ************************************************************* MAKE ONE BIG LAKE: ************************************************************ //  
/*===============================================================================================================================================*/
// NONE FOR NOW:
/*-----------------------------------------------------------------------------------------------------------------------------------------------*/
    
	    // CREATE THE LAKE CLASS:
		int lakeClass=rmDefineClass("lake");
		
		// CREATE THE LAKE CONSTRAINTS:
		int lakeConstraint=rmCreateClassDistanceConstraint("stuff vs. lake", rmClassID("lake"), 15.0);
		int lakeMediumConstraint=rmCreateClassDistanceConstraint("medium vs. lake", rmClassID("lake"), 25.0);

/*-----------------------------------------------------------------------------------------------------------------------------------------------*/		
	
	    int whichChoices=rmRandInt(1,2);
		
/*-----------------------------------------------------------------------------------------------------------------------------------------------*/		
		
		if ( whichChoices == 1 )
{		
		int lakeID=rmCreateArea("small lake 1");
		rmSetAreaLocation(lakeID, 0.50, 0.50);
		
		rmAddAreaInfluenceSegment(lakeID, 0.300, 0.500, 0.300, 0.600);
		rmAddAreaInfluenceSegment(lakeID, 0.300, 0.600, 0.400, 0.700);
		rmAddAreaInfluenceSegment(lakeID, 0.400, 0.700, 0.500, 0.700);
		rmAddAreaInfluenceSegment(lakeID, 0.500, 0.700, 0.700, 0.500);
		rmAddAreaInfluenceSegment(lakeID, 0.700, 0.500, 0.700, 0.400);
		rmAddAreaInfluenceSegment(lakeID, 0.700, 0.400, 0.600, 0.300);
		rmAddAreaInfluenceSegment(lakeID, 0.600, 0.300, 0.500, 0.300);
		rmAddAreaInfluenceSegment(lakeID, 0.500, 0.300, 0.300, 0.500);
		
		rmSetAreaSize(lakeID, 0.1, 0.1);
		rmSetAreaCoherence(lakeID, 1.0);

        rmSetAreaWaterType(lakeID, "Coastal Japan");
		   //rmSetAreaWaterType(lakeID, "Amazon River");
	    rmSetAreaBaseHeight(lakeID, 1.0);
	    
		rmSetAreaMinBlobs(lakeID, 1);
	    rmSetAreaMaxBlobs(lakeID, 1);
	    rmSetAreaMinBlobDistance(lakeID, 1.0);
	    rmSetAreaMaxBlobDistance(lakeID, 1.0);
	    
		rmAddAreaToClass(lakeID, lakeClass);
	    rmSetAreaWarnFailure(lakeID, false);

        rmBuildArea(lakeID);
		
/*-----------------------------------------------------------------------------------------------------------------------------------------------*/		
	    
		// WHALES CONSTRAINTS:
	    //int fishVsWhale=rmCreateTypeDistanceConstraint("fish vs whale", "AbstractWhale", 10.0);
	    int whaleVsWhaleID=rmCreateTypeDistanceConstraint("whale vs whale", "AbstractWhale", 75.0);
	    int whaleLand = rmCreateTerrainDistanceConstraint("whale vs land", "land", true, 30.0);
        int whaleEdgeConstraint=rmCreatePieConstraint("whale vs edge of map", 0.5, 0.5, 0, rmGetMapXSize()-20, 0, 0, 0);

/*-----------------------------------------------------------------------------------------------------------------------------------------------*/

		
		// THE WHALES BELUGA 1:
		int whaleID=rmCreateObjectDef("whale");
        rmAddObjectDefItem(whaleID, "HumpbackWhale", 1, 9.0);
        rmSetObjectDefMinDistance(whaleID, 0.0);
        rmSetObjectDefMaxDistance(whaleID, rmXFractionToMeters(0.5));
        rmAddObjectDefConstraint(whaleID, whaleVsWhaleID);
        rmAddObjectDefConstraint(whaleID, whaleLand);
		//rmAddObjectDefConstraint(whaleID, whaleEdgeConstraint);
		//rmAddObjectDefConstraint(whaleID, Northward);
		
		if (cNumberNonGaiaPlayers <=2)
        rmPlaceObjectDefAtLoc(whaleID, 0, 0.5, 0.5, 3.0*cNumberNonGaiaPlayers);
		else
		rmPlaceObjectDefAtLoc(whaleID, 0, 0.5, 0.5, 1.5*cNumberNonGaiaPlayers);
}
/*-----------------------------------------------------------------------------------------------------------------------------------------------*/
		else
{	
		// DEFINE THE MIDDLE RIVER:
	    // int riverID = rmRiverCreate(-1, "Coastal Japan", 5, 5, 24, 24);
		   int riverID = rmRiverCreate(-1, "Japan_HC", 5, 5, 24, 24);
	    
		// DEFINE THE - start - middle - end - OF THE RIVER USING WAY POINTS:
		rmRiverAddWaypoint(riverID, 0.10, 0.90);
	    rmRiverAddWaypoint(riverID, 0.90, 0.10);
		
		// NO PASSAGE FOR RIVERONE:
		// rmRiverSetShallowRadius(riverID, 6);
		   rmRiverSetShallowRadius(riverID, 8);
	    // rmRiverAddShallow(riverID, rmRandFloat(0.5, 0.5));
		   rmRiverAddShallow(riverID, 0.25);
		   rmRiverAddShallow(riverID, 0.75);
	
	    // RIVER SET BANK NOISE PARAMS:
		rmRiverSetBankNoiseParams(riverID, 0.07, 2, 1.5, 10.0, 0.667, 2.0);
	    
		// BUILD THE RIVER:
		rmRiverBuild(riverID);
		
		// LETTING US VIEW THE RIVER EVEN WITH THE BLACK FOG:
		rmRiverReveal(riverID, 2); 
}

/*-----------------------------------------------------------------------------------------------------------------------------------------------*/
// ***************************************************** DEFINE AND PLACE THE CLIFFS: ********************************************************** //
/*-----------------------------------------------------------------------------------------------------------------------------------------------*/

        // CREATE THE CLASS CLIFF:
        int classCliff=rmDefineClass("cliff");
		
		// CREATE THE CLIFF CONSTRAINTS:
		int cliffConstraint=rmCreateClassDistanceConstraint("cliff vs. cliff", rmClassID("cliff"), 15.0);
		int cliffMediumConstraint=rmCreateClassDistanceConstraint("medium vs. cliff", rmClassID("cliff"), 25.0);
		
		
/*-----------------------------------------------------------------------------------------------------------------------------------------------*/		
	  
	    int numTries=cNumberNonGaiaPlayers*0.25;
	  
/*-----------------------------------------------------------------------------------------------------------------------------------------------*/	  
	  
        for(i=0; <numTries)
   {
        int cliffID=rmCreateArea("cliff"+i);
	    rmSetAreaLocation(cliffID, 0.40, 0.85);
        rmSetAreaSize(cliffID, rmAreaTilesToFraction(950), rmAreaTilesToFraction(950));
        rmSetAreaWarnFailure(cliffID, false);
        
		rmSetAreaCliffType(cliffID, "Patagonia");
		
		// rmSetAreaCliffEdge(cliffID, 2, 0.3, 0.1, 1.0, 0);
		   rmSetAreaCliffEdge(cliffID, 1, 1.0, 0.1, 1.0, 0);
		      //rmSetAreaCliffEdge(cliffID, 2, 0.4, 0.1, 1.0, 0);
        
		//rmSetAreaCliffPainting(cliffID, false, true, true, 1.5, true);
        
		//rmSetAreaCliffHeight(cliffID, 7, 2.0, 0.5);
		   //rmSetAreaCliffHeight(cliffID, 3, 2.0, 0.5);
		     rmSetAreaCliffHeight(cliffID, 6, 1.0, 1.0);
        
		//rmSetAreaHeightBlend(cliffID, 1);
        //rmSetAreaObeyWorldCircleConstraint(cliffID, false);
        rmAddAreaToClass(cliffID, rmClassID("cliff")); 
	    rmSetAreaMix(cliffID, "patagonia_dirt");
      
	    //rmAddAreaConstraint(cliffID, lakeMediumConstraint);
	    
        //rmSetAreaMinBlobs(cliffID, 2);
        //rmSetAreaMaxBlobs(cliffID, 3);
        //rmSetAreaMinBlobDistance(cliffID, 5.0);
        //rmSetAreaMaxBlobDistance(cliffID, 20.0);
        
		//rmSetAreaSmoothDistance(cliffID, 5);
        rmSetAreaCoherence(cliffID, 0.80);		// higher = tries to make round
		
        rmBuildArea(cliffID);
   } 
   
/*-----------------------------------------------------------------------------------------------------------------------------------------------*/

        for(i=0; <numTries)
   {
        int cliff2ID=rmCreateArea("The Southern Cliff"+i);
	    rmSetAreaLocation(cliff2ID, 0.15, 0.60);
        rmSetAreaSize(cliff2ID, rmAreaTilesToFraction(950), rmAreaTilesToFraction(950));
        rmSetAreaWarnFailure(cliff2ID, false);
        
		rmSetAreaCliffType(cliff2ID, "Patagonia");
		
		// rmSetAreaCliffEdge(cliff2ID, 2, 0.3, 0.1, 1.0, 0);
		   rmSetAreaCliffEdge(cliff2ID, 1, 1.0, 0.1, 1.0, 0);
		      //rmSetAreaCliffEdge(cliff2ID, 2, 0.4, 0.1, 1.0, 0);
        
		//rmSetAreaCliffPainting(cliff2ID, false, true, true, 1.5, true);
        
		//rmSetAreaCliffHeight(cliff2ID, 7, 2.0, 0.5);
		   //rmSetAreaCliffHeight(cliff2ID, 3, 2.0, 0.5);
		     rmSetAreaCliffHeight(cliff2ID, 6, 1.0, 1.0);
        
		//rmSetAreaHeightBlend(cliff2ID, 1);
        //rmSetAreaObeyWorldCircleConstraint(cliff2ID, false);
        rmAddAreaToClass(cliff2ID, rmClassID("cliff")); 
	    rmSetAreaMix(cliff2ID, "patagonia_dirt");
      
	    //rmAddAreaConstraint(cliff2ID, lakeMediumConstraint);
	    
        //rmSetAreaMinBlobs(cliff2ID, 2);
        //rmSetAreaMaxBlobs(cliff2ID, 3);
        //rmSetAreaMinBlobDistance(cliff2ID, 5.0);
        //rmSetAreaMaxBlobDistance(cliff2ID, 20.0);
        
		//rmSetAreaSmoothDistance(cliff2ID, 5);
        rmSetAreaCoherence(cliff2ID, 0.80);		// higher = tries to make round
		
        rmBuildArea(cliff2ID);
   }    
   
/*-----------------------------------------------------------------------------------------------------------------------------------------------*/   

        int smallCliffHeight=rmRandInt(0,10);
		int smallMesaID=rmCreateArea("small mesa"+i);
		rmSetAreaSize(smallMesaID, rmAreaTilesToFraction(950), rmAreaTilesToFraction(950));  
		rmSetAreaWarnFailure(smallMesaID, false);
		rmSetAreaCliffType(smallMesaID, "patagonia");
		rmAddAreaToClass(smallMesaID, rmClassID("cliff"));	
		rmSetAreaCliffEdge(smallMesaID, 1, 1.0, 0.1, 1.0, 0);
		rmSetAreaCliffHeight(smallMesaID, rmRandInt(6, 8), 1.0, 1.0);  //was rmRandInt(6, 8)
		rmSetAreaCoherence(smallMesaID, 0.80);
		rmSetAreaLocation(smallMesaID, 0.85, 0.40); 
		//rmAddAreaInfluenceSegment(smallMesaID, 0.48, 0.43, 0.5, 0.40);  //Bottom - Original segment
		//rmAddAreaInfluenceSegment(smallMesaID, 0.46, 0.40, 0.53, 0.38); //Right
		//rmAddAreaInfluenceSegment(smallMesaID, 0.53, 0.45, 0.53, 0.38); //Top - Original segment
		//rmAddAreaInfluenceSegment(smallMesaID, 0.53, 0.45, 0.48, 0.43); //Left
		rmBuildArea(smallMesaID);
		
/*-----------------------------------------------------------------------------------------------------------------------------------------------*/
        
		smallCliffHeight=rmRandInt(0,10);
		int smallMesa2ID=rmCreateArea("The Southern Small Mesa"+i);
		rmSetAreaSize(smallMesa2ID, rmAreaTilesToFraction(950), rmAreaTilesToFraction(950));  
		rmSetAreaWarnFailure(smallMesa2ID, false);
		rmSetAreaCliffType(smallMesa2ID, "patagonia");
		rmAddAreaToClass(smallMesa2ID, rmClassID("cliff"));	
		rmSetAreaCliffEdge(smallMesa2ID, 1, 1.0, 0.1, 1.0, 0);
		rmSetAreaCliffHeight(smallMesa2ID, rmRandInt(6, 8), 1.0, 1.0);  //was rmRandInt(6, 8)
		rmSetAreaCoherence(smallMesa2ID, 0.80);
		rmSetAreaLocation(smallMesa2ID, 0.60, 0.15); 
		//rmAddAreaInfluenceSegment(smallMesa2ID, 0.48, 0.43, 0.5, 0.40);  //Bottom - Original segment
		//rmAddAreaInfluenceSegment(smallMesa2ID, 0.46, 0.40, 0.53, 0.38); //Right
		//rmAddAreaInfluenceSegment(smallMesa2ID, 0.53, 0.45, 0.53, 0.38); //Top - Original segment
		//rmAddAreaInfluenceSegment(smallMesa2ID, 0.53, 0.45, 0.48, 0.43); //Left
		rmBuildArea(smallMesa2ID);		
   

/*===============================================================================================================================================*/
// **************************************************** DEFINE AND PLACE THE NATIVE TRIBES: **************************************************** //  
/*===============================================================================================================================================*/

	    whichChoices=rmRandInt(1,2);
		
		if ( whichChoices == 1 )
	    
{
		if (subCiv0 == rmGetCivID("zen"))
   {  
		int nativeVillage1ID = -1;
		int nativeVillageType = rmRandInt(1,5);
		nativeVillage1ID = rmCreateGrouping("native village 1", "native zen temple cj 0"+nativeVillageType);
		rmSetGroupingMinDistance(nativeVillage1ID, 0.0);
		rmSetGroupingMaxDistance(nativeVillage1ID, 0.0);
		rmAddGroupingToClass(nativeVillage1ID, rmClassID("importantItem"));
		rmAddGroupingToClass(nativeVillage1ID, rmClassID("natives"));
		//rmAddGroupingConstraint(nativeVillage1ID, importantItemConstraint);
		//rmAddGroupingConstraint(nativeVillage1ID, nativesConstraint);
		
		rmPlaceGroupingAtLoc(nativeVillage1ID, 0, 0.750, 0.250);
		
	}	
		
		if (subCiv1 == rmGetCivID("jesuit"))
   {  
		int nativeVillage2ID = -1;
		nativeVillageType = -1;
		nativeVillageType = rmRandInt(1,5);
		nativeVillage2ID = rmCreateGrouping("native village 2", "native jesuit mission cj 0"+nativeVillageType);
		rmSetGroupingMinDistance(nativeVillage2ID, 0.0);
		rmSetGroupingMaxDistance(nativeVillage2ID, 0.0);
		rmAddGroupingToClass(nativeVillage2ID, rmClassID("importantItem"));
		rmAddGroupingToClass(nativeVillage2ID, rmClassID("natives"));
		//rmAddGroupingConstraint(nativeVillage2ID, importantItemConstraint);
		//rmAddGroupingConstraint(nativeVillage2ID, nativesConstraint);
		
		rmPlaceGroupingAtLoc(nativeVillage2ID, 0, 0.250, 0.750);
   }
   
}	
		
/*===============================================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.35);
/*===============================================================================================================================================*/
// ****************************************************** SET UP THE PLAYER START LOCATIONS: *************************************************** //	
/*===============================================================================================================================================*/
// NONE FOR NOW:
/*-----------------------------------------------------------------------------------------------------------------------------------------------*/

        if(rmRandFloat(0,1) > 0.50)
	{
		rmSetPlacementTeam(0);
		rmPlacePlayersLine(0.65, 0.85, 0.85, 0.65, 0, 0.0);

		rmSetPlacementTeam(1);
		rmPlacePlayersLine(0.35, 0.15, 0.15, 0.35, 0, 0.0);
	}
	    else
	{
		rmSetPlacementTeam(0);
		rmPlacePlayersLine(0.35, 0.15, 0.15, 0.35, 0, 0.0);
	
		rmSetPlacementTeam(1);
		rmPlacePlayersLine(0.65, 0.85, 0.85, 0.65, 0, 0.0);
	}
	
/*===============================================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.40);
/*===============================================================================================================================================*/		
// ********************************************************** SET UP THE PLAYER AREAS: ********************************************************* //	
/*===============================================================================================================================================*/
// NONE FOR NOW:
/*-----------------------------------------------------------------------------------------------------------------------------------------------*/

	    float playerFraction=rmAreaTilesToFraction(3250);
		
/*-----------------------------------------------------------------------------------------------------------------------------------------------*/
		
        for(i=1; <cNumberPlayers)
   {
        // CREATE THE AREA.
        int id=rmCreateArea("Player"+i);
        
		// ASSIGN TO THE PLAYER:
        rmSetPlayerArea(i, id);
        
		// SET THE SIZE.
        rmSetAreaSize(id, playerFraction, playerFraction);
        
		// ADD AREA TO CLASS:
		rmAddAreaToClass(id, classPlayer);
        
		// SET AREA MIN AND MAX BLOBS:
		rmSetAreaMinBlobs(id, 1);
        rmSetAreaMaxBlobs(id, 1);
        
		// ADD AREA CONSTRAINT:
		//rmAddAreaConstraint(id, playerConstraint); 
        //rmAddAreaConstraint(id, playerEdgeConstraint);
		
		// SET AREA COHERENCE:
		rmSetAreaCoherence(id, 1.0);
		
		// SET AREA MIX:
		//rmSetAreaMix(id, "rockies_snow");
		
        // SET AREA LOC PLAYER:
		rmSetAreaLocPlayer(id, i);
	   
	    // SET AREA TERRAIN TYPE:
		// rmSetAreaTerrainType(id, "carolina\marshflats");
		
		// SET AREA BASE HEIGHT:
		// rmSetAreaBaseHeight(id, 8.0);
        
		// SET AREA WARN FAILURE:
		rmSetAreaWarnFailure(id, false);
   }
	    // BUILD THE AREAS:
	    rmBuildAllAreas();
   
/*===============================================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.45);
/*===============================================================================================================================================*/
// ************************************************** DEFINE AND PLACE THE NATIVE VILLAGES: **************************************************** //
/*===============================================================================================================================================*/
// NONE FOR NOW:
/*-----------------------------------------------------------------------------------------------------------------------------------------------*/

        if (subCiv2 == rmGetCivID("zen"))
   {  
		int nativeVillage3ID = -1;
		nativeVillageType = rmRandInt(1,5);
		nativeVillage3ID = rmCreateGrouping("native village 3", "native zen temple cj 0"+nativeVillageType);
		rmSetGroupingMinDistance(nativeVillage3ID, 0.0);
		rmSetGroupingMaxDistance(nativeVillage3ID, 0.0);
		rmAddGroupingToClass(nativeVillage3ID, rmClassID("importantItem"));
		rmAddGroupingToClass(nativeVillage3ID, rmClassID("natives"));
		//rmAddGroupingConstraint(nativeVillage3ID, importantItemConstraint);
		//rmAddGroupingConstraint(nativeVillage3ID, nativesConstraint);
		
		rmPlaceGroupingAtLoc(nativeVillage3ID, 0, 0.675, 0.675);
   }
   
/*----------------------------------------------------------------------------------------------------------------*/

        if (subCiv3 == rmGetCivID("jesuit"))
   {  
		int nativeVillage4ID = -1;
		nativeVillageType = rmRandInt(1,5);
		nativeVillage4ID = rmCreateGrouping("native village 4", "native jesuit mission cj 0"+nativeVillageType);
		rmSetGroupingMinDistance(nativeVillage4ID, 0.0);
		rmSetGroupingMaxDistance(nativeVillage4ID, 0.0);
		rmAddGroupingToClass(nativeVillage4ID, rmClassID("importantItem"));
		rmAddGroupingToClass(nativeVillage4ID, rmClassID("natives"));
		//rmAddGroupingConstraint(nativeVillage4ID, importantItemConstraint);
		//rmAddGroupingConstraint(nativeVillage4ID, nativesConstraint);
		
		rmPlaceGroupingAtLoc(nativeVillage4ID, 0, 0.325, 0.325);
   }

/*----------------------------------------------------------------------------------------------------------------*/
	    
		if (cNumberNonGaiaPlayers <=2)
{		
		if (subCiv4 == rmGetCivID("zen"))
   {  
		int nativeVillage5ID = -1;
		nativeVillageType = rmRandInt(1,5);
		nativeVillage5ID = rmCreateGrouping("native village 5", "native zen temple cj 0"+nativeVillageType);
		rmSetGroupingMinDistance(nativeVillage5ID, 0.0);
		rmSetGroupingMaxDistance(nativeVillage5ID, 0.0);
		rmAddGroupingToClass(nativeVillage5ID, rmClassID("importantItem"));
		rmAddGroupingToClass(nativeVillage5ID, rmClassID("natives"));
		//rmAddGroupingConstraint(nativeVillage5ID, importantItemConstraint);
		//rmAddGroupingConstraint(nativeVillage5ID, nativesConstraint);
		
		rmPlaceGroupingAtLoc(nativeVillage5ID, 0, 0.850, 0.650);
		
   }
   
/*----------------------------------------------------------------------------------------------------------------*/

        if (subCiv5 == rmGetCivID("jesuit"))
   {  
		int nativeVillage6ID = -1;
		nativeVillageType = rmRandInt(1,5);
		nativeVillage6ID = rmCreateGrouping("native village 6", "native jesuit mission cj 0"+nativeVillageType);
		rmSetGroupingMinDistance(nativeVillage6ID, 0.0);
		rmSetGroupingMaxDistance(nativeVillage6ID, 0.0);
		rmAddGroupingToClass(nativeVillage6ID, rmClassID("importantItem"));
		rmAddGroupingToClass(nativeVillage6ID, rmClassID("natives"));
		//rmAddGroupingConstraint(nativeVillage6ID, importantItemConstraint);
		//rmAddGroupingConstraint(nativeVillage6ID, nativesConstraint);
		
		rmPlaceGroupingAtLoc(nativeVillage6ID, 0, 0.150, 0.350);
		
   }     
}

/*===============================================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.50);
/*===============================================================================================================================================*/
// ******************************************* DEFINE THE TCID AND THE STARTING UNITS AND RESOURCES: ******************************************* //
/*===============================================================================================================================================*/
// NONE FOR NOW:
/*-----------------------------------------------------------------------------------------------------------------------------------------------*/

    // CREATE THE CLASS RESOURCE:    
    int classResource=rmDefineClass("resource");

    // CREATE THE RESOURCE CONSTRAINTS:
	int resourceConstraint=rmCreateClassDistanceConstraint("stuff vs resource", rmClassID("resource"), 15.0);
	
	// FRUITS AVOIDANCE:
	int fruitsConstraint=rmCreateTypeDistanceConstraint("stuff vs fruits", "AbstractFruit", 15.0);
	int fruitsMediumConstraint=rmCreateTypeDistanceConstraint("medium vs fruits", "AbstractFruit", 35.0);
	int fruitsFarConstraint=rmCreateTypeDistanceConstraint("far vs fruits", "AbstractFruit", 65.0);
	
	// CAPYBARA AVOIDANCE:
	int foodConstraint=rmCreateTypeDistanceConstraint("stuff vs food", "ypGiantSalamander", 15.0);
    int foodMediumConstraint=rmCreateTypeDistanceConstraint("medium vs food", "ypGiantSalamander", 35.0);
    int foodFarConstraint=rmCreateTypeDistanceConstraint("far vs food", "ypGiantSalamander", 65.0);
	
	// NUGGET AVOIDANCE:
	int nuggetConstraint=rmCreateTypeDistanceConstraint("stuff vs nugget", "AbstractNugget", 15.0);
	int nuggetMediumConstraint=rmCreateTypeDistanceConstraint("medium vs nugget", "AbstractNugget", 35.0);
	int nuggetFarConstraint=rmCreateTypeDistanceConstraint("far vs nugget", "AbstractNugget", 65.0);
	
	// CREATE THE CLASS TREE:    
    int classTree=rmDefineClass("tree");

    // CREATE THE TREE CONSTRAINTS:
	int treeConstraint=rmCreateClassDistanceConstraint("stuff vs tree", rmClassID("tree"), 15.0);
    int treeMediumConstraint=rmCreateClassDistanceConstraint("medium vs tree", rmClassID("tree"), 30.0);
    int treeFarConstraint=rmCreateClassDistanceConstraint("far vs tree", rmClassID("tree"), 65.0);
		
/*-----------------------------------------------------------------------------------------------------------------------------------------------*/		
		
	    // TCFLOAT:
		int TCfloat = -1;
	    if (cNumberTeams == 2)
	{
		if (cNumberNonGaiaPlayers > 2)
		TCfloat = 0;
		else if (cNumberNonGaiaPlayers > 5)
		TCfloat = 0;
		else 
		TCfloat = 0;
	}
	    else 
		TCfloat = 0;
		
/*-----------------------------------------------------------------------------------------------------------------------------------------------*/		

	    // DEFINE THE TCID:
		int TCID = rmCreateObjectDef("player TC");
	    if (rmGetNomadStart())
		{
		rmAddObjectDefItem(TCID, "CoveredWagon", 1, 0.0);
		}
	    else
		{
		rmAddObjectDefItem(TCID, "TownCenter", 1, 0.0);
		}

	    rmSetObjectDefMinDistance(TCID, 0.0);
	    rmSetObjectDefMaxDistance(TCID, TCfloat);
		rmAddObjectDefToClass(TCID, rmClassID("resource"));

	/*  
	    // THIS IS INTERESTING TO KEEP FOR FUTURE REFERENCE:
		if (cNumberTeams == 2)
		if (rmGetNumberPlayersOnTeam(0) == rmGetNumberPlayersOnTeam(1))
		rmAddObjectDefConstraint(TCID, avoidImpassableLand);
		else
		rmAddObjectDefConstraint(TCID, nativesConstraint);
	    else
		rmAddObjectDefConstraint(TCID, avoidAll);
	*/
	
/*-----------------------------------------------------------------------------------------------------------------------------------------------*/

        // DEFINE THE STARTING UNITS:
		int startingUnits = rmCreateStartingUnitsObjectDef(5.0);
		rmAddObjectDefToClass(startingUnits, rmClassID("resource"));
        rmSetObjectDefMinDistance(startingUnits, 8.0);
        rmSetObjectDefMaxDistance(startingUnits, 15.0);
	    rmAddObjectDefConstraint(startingUnits, resourceConstraint);

/*-----------------------------------------------------------------------------------------------------------------------------------------------*/
        
		// DEFINE THE PLAYER BERRY:
		int playerBerryID=rmCreateObjectDef("player berries");
        rmAddObjectDefItem(playerBerryID, "berryBush", rmRandInt(7,12), 8.0);
		rmAddObjectDefToClass(playerBerryID, rmClassID("resource"));
        rmSetObjectDefMinDistance(playerBerryID, 15);
        rmSetObjectDefMaxDistance(playerBerryID, 20);
	    rmAddObjectDefConstraint(playerBerryID, resourceConstraint);
        rmAddObjectDefConstraint(playerBerryID, fruitsMediumConstraint);		
		
/*-----------------------------------------------------------------------------------------------------------------------------------------------*/		

	    // DEFINE THE PLAYER SILVER:
		int playerSilverID = rmCreateObjectDef("player mine");
	    rmAddObjectDefItem(playerSilverID, "minegold", 1, 0);
		rmAddObjectDefToClass(playerSilverID, rmClassID("resource"));
	    rmSetObjectDefMinDistance(playerSilverID, 15.0);
	    rmSetObjectDefMaxDistance(playerSilverID, 20.0);
        
		rmAddObjectDefConstraint(playerSilverID, avoidAll);
		rmAddObjectDefConstraint(playerSilverID, fruitsConstraint);
		rmAddObjectDefConstraint(playerSilverID, resourceConstraint);
		
/*-----------------------------------------------------------------------------------------------------------------------------------------------*/

	    // DEFINE THE PLAYER FOOD:
		int playerFoodID=rmCreateObjectDef("player Food");
        rmAddObjectDefItem(playerFoodID, "ypGiantSalamander", rmRandInt(5,7), 5.0);
		rmAddObjectDefToClass(playerFoodID, rmClassID("resource"));
        rmSetObjectDefMinDistance(playerFoodID, 10);
        rmSetObjectDefMaxDistance(playerFoodID, 25);
		rmSetObjectDefCreateHerd(playerFoodID, true);
	    
		rmAddObjectDefConstraint(playerFoodID, avoidAll);
        rmAddObjectDefConstraint(playerFoodID, foodMediumConstraint);
		rmAddObjectDefConstraint(playerFoodID, fruitsConstraint);
		rmAddObjectDefConstraint(playerFoodID, resourceConstraint);
		
/*-----------------------------------------------------------------------------------------------------------------------------------------------*/		

	    // DEFINE THE PLAYER NUGGET:
		int playerNuggetID= rmCreateObjectDef("player nugget"); 
	    rmAddObjectDefItem(playerNuggetID, "Nugget", 1, 0.0);
		rmAddObjectDefToClass(playerNuggetID, rmClassID("resource"));
	    rmSetNuggetDifficulty(1, 1);
		rmSetObjectDefMinDistance(playerNuggetID, 20.0);
	    rmSetObjectDefMaxDistance(playerNuggetID, 30.0);
	    
		rmAddObjectDefConstraint(playerNuggetID, nuggetConstraint);
  	    rmAddObjectDefConstraint(playerNuggetID, avoidAll);
	    rmAddObjectDefConstraint(playerNuggetID, foodConstraint);
		rmAddObjectDefConstraint(playerNuggetID, fruitsConstraint);
	    rmAddObjectDefConstraint(playerNuggetID, resourceConstraint);
		
/*-----------------------------------------------------------------------------------------------------------------------------------------------*/		

	    // DEFINE THE PLAYER TREE:
		int playerTreeID=rmCreateObjectDef("player trees");
        rmAddObjectDefItem(playerTreeID, "ypTreeJapaneseMaple", rmRandInt(12,16), 12.0);
		rmAddObjectDefToClass(playerTreeID, rmClassID("resource"));
		rmAddObjectDefToClass(playerTreeID, rmClassID("tree"));
        rmSetObjectDefMinDistance(playerTreeID, 32);
        rmSetObjectDefMaxDistance(playerTreeID, 40);
	    rmAddObjectDefConstraint(playerTreeID, avoidAll);
		rmAddObjectDefConstraint(playerTreeID, resourceConstraint);
		rmAddObjectDefConstraint(playerTreeID, treeMediumConstraint);
		rmAddObjectDefConstraint(playerTreeID, foodConstraint);
		rmAddObjectDefConstraint(playerTreeID, fruitsConstraint);
		rmAddObjectDefConstraint(playerTreeID, nuggetConstraint);
		
/*-----------------------------------------------------------------------------------------------------------------------------------------------*/
	
        // WATER FLAG AVOIDANCE:
		// int flagEdgeConstraint = rmCreatePieConstraint("flags stay near edge of map", 0.5, 0.5, rmGetMapXSize()-180, rmGetMapXSize()-40, 0, 0, 0);
	    int flagEdgeConstraint=rmCreatePieConstraint("flag edge of map", 0.5, 0.5, 0, rmGetMapXSize()-10, 0, 0, 0);
		int flagVsFlag = rmCreateTypeDistanceConstraint("flag avoid same", "HomeCityWaterSpawnFlag", 15);
	    int flagLand = rmCreateTerrainDistanceConstraint("flag vs land", "land", true, 8.0);
	    
		int boatLand = rmCreateTerrainDistanceConstraint("boat vs land", "land", true, 10.0);
	    int boatConstraint = rmCreateTypeDistanceConstraint("boat vs flag", "HomeCityWaterSpawnFlag", 25);
	    //int flagEdgeConstraint = rmCreatePieConstraint("flags stay near edge of map", 0.5, 0.5, rmGetMapXSize()-20, rmGetMapXSize()-10, 0, 0, 0);
	    //int flagBoxConstraint=rmCreateBoxConstraint("flag area", 0, 0.5, 0.6, 0.9, 0.0);

/*-----------------------------------------------------------------------------------------------------------------------------------------------*/		
		
		// WATER HC ARRIVAL POINT:

        int waterFlagID = 0;
        
		for(i=1; <cNumberPlayers)
    {
        waterFlagID=rmCreateObjectDef("HC water flag "+i);
        rmAddObjectDefItem(waterFlagID, "HomeCityWaterSpawnFlag", 1, 20.0);
		rmAddClosestPointConstraint(flagEdgeConstraint);
		rmAddClosestPointConstraint(flagVsFlag);
		rmAddClosestPointConstraint(flagLand);
	} 
    
/*===============================================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.675);
/*===============================================================================================================================================*/
// ***************************************** PLACE THE TCID AND THE STARTING UNITS AND THE RESOURCES: ****************************************** //
/*===============================================================================================================================================*/
// NONE FOR NOW:
/*-----------------------------------------------------------------------------------------------------------------------------------------------*/

	    for(i=1; <cNumberPlayers) 
	{
        // PLACE THE TCID:
		rmPlaceObjectDefAtLoc(TCID, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
        vector TCLoc = rmGetUnitPosition(rmGetUnitPlacedOfPlayer(TCID, i));
        
		// PLACE THE STARTING UNITS:
		rmPlaceObjectDefAtLoc(startingUnits, i, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc)));
        
		// PLACE THE PLAYER SILVER:
		rmPlaceObjectDefAtLoc(playerSilverID, 0, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc)));
        
		// PLACE THE PLAYER CAPYBARA:
		rmPlaceObjectDefAtLoc(playerBerryID, 0, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc)));
 		
		// PLACE THE PLAYER CAPYBARA:
		rmPlaceObjectDefAtLoc(playerFoodID, 0, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc)));
        
		// PLAYER NUGGET:
		rmPlaceObjectDefAtLoc(playerNuggetID, 0, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc)));
       		
        // PLACE THE PLAYER TREE:
		rmPlaceObjectDefAtLoc(playerTreeID, 0, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc)));
		rmPlaceObjectDefAtLoc(playerTreeID, 0, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc)));
		rmPlaceObjectDefAtLoc(playerTreeID, 0, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc)));
		rmPlaceObjectDefAtLoc(playerTreeID, 0, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc)));
		
		// NOMAD:
		if(ypIsAsian(i) && rmGetNomadStart() == false)
        rmPlaceObjectDefAtLoc(ypMonasteryBuilder(i, 1), i, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc)));
      
        vector closestPoint = rmFindClosestPointVector(TCLoc, rmXFractionToMeters(1.0));
	    rmPlaceObjectDefAtLoc(waterFlagID, i, rmXMetersToFraction(xsVectorGetX(closestPoint)), rmZMetersToFraction(xsVectorGetZ(closestPoint)));
        
		// PLACE A CARAVEL:
		int catamaranID=rmCreateObjectDef("Caravel"+i);
        rmAddObjectDefItem(catamaranID, "Caravel", 1, 15.0);
		rmAddClosestPointConstraint(boatConstraint);
		rmAddClosestPointConstraint(boatLand);
        rmPlaceObjectDefAtLoc(catamaranID, i, rmXMetersToFraction(xsVectorGetX(closestPoint)), rmZMetersToFraction(xsVectorGetZ(closestPoint)));

	}
        rmClearClosestPointConstraints();

/*===============================================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.70);
/*===============================================================================================================================================*/
// ******************************************************* DEFINE AND PLACE THE FOREST: ******************************************************** //	
/*===============================================================================================================================================*/
// NONE FOR NOW:
/*-----------------------------------------------------------------------------------------------------------------------------------------------*/

        // CREATE THE FOREST CLASS:
		int forestClass=rmDefineClass("classForest");
		
		// CREATE THE FOREST CONSTRAINT:
		int forestConstraint=rmCreateClassDistanceConstraint("forest vs. forest", rmClassID("classForest"), 15.0);
	    int forestMediumConstraint=rmCreateClassDistanceConstraint("medium vs. forest", rmClassID("classForest"), 45.0);
        int forestCloseConstraint=rmCreateClassDistanceConstraint("close vs. forest", rmClassID("classForest"), 25.0);
        int forestFarConstraint=rmCreateClassDistanceConstraint("far vs. forest", rmClassID("classForest"), 55.0);

/*-----------------------------------------------------------------------------------------------------------------------------------------------*/        
		
		if (cNumberNonGaiaPlayers <=2)
		numTries=8*cNumberNonGaiaPlayers;
		else
		numTries=4*cNumberNonGaiaPlayers;
		
        int failCount=0;
		
/*-----------------------------------------------------------------------------------------------------------------------------------------------*/		

        for (i=0; <numTries) 
{   
        int forest=rmCreateArea("The Northern Forest"+i);
        rmSetAreaWarnFailure(forest, false);
        rmSetAreaSize(forest, rmAreaTilesToFraction(200), rmAreaTilesToFraction(350));
        
		// rmSetAreaForestType(forest, forestType);
		   rmSetAreaForestType(forest, "Coastal Japan Forest");
        
		rmSetAreaForestDensity(forest, 0.75);
        rmSetAreaForestClumpiness(forest, 0.25);
        rmSetAreaForestUnderbrush(forest, 0.25);
        
		rmSetAreaCoherence(forest, 0.4);
        rmAddAreaToClass(forest, rmClassID("classForest")); 
        
		rmAddAreaConstraint(forest, forestMediumConstraint);
        rmAddAreaConstraint(forest, nativesConstraint); 
        rmAddAreaConstraint(forest, avoidImpassableLand);
        rmAddAreaConstraint(forest, playerConstraint);
		rmAddAreaConstraint(forest, playerEdgeConstraint);
        rmAddAreaConstraint(forest, lakeConstraint);
		rmAddAreaConstraint(forest, cliffMediumConstraint);
		rmAddAreaConstraint(forest, Northward);
    
        if(rmBuildArea(forest)==false)
    {
        // Stop trying once we fail 7 times in a row.
        failCount++;
        if(failCount==7)
        break;
    }
        else
        failCount=0; 
} 

/*-----------------------------------------------------------------------------------------------------------------------------------------------*/

        for (i=0; <numTries) 
{   
        int forest2=rmCreateArea("The Southern Forest"+i);
        rmSetAreaWarnFailure(forest2, false);
        rmSetAreaSize(forest2, rmAreaTilesToFraction(200), rmAreaTilesToFraction(350));
        
		// rmSetAreaForestType(forest2, forestType);
		   rmSetAreaForestType(forest2, "Coastal Japan Forest");
        
		rmSetAreaForestDensity(forest2, 0.75);
        rmSetAreaForestClumpiness(forest2, 0.25);
        rmSetAreaForestUnderbrush(forest2, 0.25);
        
		rmSetAreaCoherence(forest2, 0.4);
        rmAddAreaToClass(forest2, rmClassID("classForest")); 
        
		rmAddAreaConstraint(forest2, forestMediumConstraint);
        rmAddAreaConstraint(forest2, nativesConstraint); 
        rmAddAreaConstraint(forest2, avoidImpassableLand);
        rmAddAreaConstraint(forest2, playerConstraint);
		rmAddAreaConstraint(forest2, playerEdgeConstraint);
        rmAddAreaConstraint(forest2, lakeConstraint);
		rmAddAreaConstraint(forest2, cliffMediumConstraint);
		rmAddAreaConstraint(forest2, Southward);
    
        if(rmBuildArea(forest2)==false)
    {
        // Stop trying once we fail 7 times in a row.
        failCount++;
        if(failCount==7)
        break;
    }
        else
        failCount=0; 
} 

/*===============================================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.75);
/*===============================================================================================================================================*/
// *************************************************** DEFINE AND PLACE THE SILVER MINES: ****************************************************** //
/*===============================================================================================================================================*/
// NONE FOR NOW:
/*-----------------------------------------------------------------------------------------------------------------------------------------------*/

	    int silverConstraint=rmCreateTypeDistanceConstraint("stuff vs silver", "AbstractMine", 15.0);
		int silverMediumConstraint=rmCreateTypeDistanceConstraint("medium vs silver", "AbstractMine", 35.0);
		int silverFarConstraint=rmCreateTypeDistanceConstraint("far vs silver", "AbstractMine", 65.0);
		int silverVeryFarConstraint=rmCreateTypeDistanceConstraint("very far vs silver", "AbstractMine", 75.0);
		int silverSuperFarConstraint=rmCreateTypeDistanceConstraint("super far vs silver", "AbstractMine", 90.0);
		
/*-----------------------------------------------------------------------------------------------------------------------------------------------*/
   
        // THE WESTERN SILVER MINES:
        int silverID = rmCreateObjectDef("The Westhern Silver Mines");
        rmAddObjectDefItem(silverID, "mine", 1, 0.0);
        rmSetObjectDefMinDistance(silverID, 0.0);
        rmSetObjectDefMaxDistance(silverID, rmXFractionToMeters(0.5));
        
		rmAddObjectDefConstraint(silverID, avoidImpassableLand);
        rmAddObjectDefConstraint(silverID, silverFarConstraint);
        rmAddObjectDefConstraint(silverID, playerConstraint);
		rmAddObjectDefConstraint(silverID, playerEdgeConstraint);
        rmAddObjectDefConstraint(silverID, nativesConstraint);
		rmAddObjectDefConstraint(silverID, forestConstraint);
		rmAddObjectDefConstraint(silverID, lakeConstraint);
		rmAddObjectDefConstraint(silverID, cliffConstraint);
		rmAddObjectDefConstraint(silverID, avoidAll);
		rmAddObjectDefConstraint(silverID, Northward);
			
		if (cNumberNonGaiaPlayers <=2)
	{	
	    rmPlaceObjectDefAtLoc(silverID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*8.0);  
    } 
	    else
	{	
	    rmPlaceObjectDefAtLoc(silverID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*4.0);
    } 
	
/*-----------------------------------------------------------------------------------------------------------------------------------------------*/
        
		// THE EASTERN SILVER MINES:
        int silver2ID = rmCreateObjectDef("The Easthern Silver Mines");
        rmAddObjectDefItem(silver2ID, "mine", 1, 0.0);
        rmSetObjectDefMinDistance(silver2ID, 0.0);
        rmSetObjectDefMaxDistance(silver2ID, rmXFractionToMeters(0.5));
        
		rmAddObjectDefConstraint(silver2ID, avoidImpassableLand);
        rmAddObjectDefConstraint(silver2ID, silverFarConstraint);
        rmAddObjectDefConstraint(silver2ID, playerConstraint);
		rmAddObjectDefConstraint(silver2ID, playerEdgeConstraint);
        rmAddObjectDefConstraint(silver2ID, nativesConstraint);
		rmAddObjectDefConstraint(silver2ID, forestConstraint);
		rmAddObjectDefConstraint(silver2ID, lakeConstraint);
		rmAddObjectDefConstraint(silver2ID, cliffConstraint);
		rmAddObjectDefConstraint(silver2ID, avoidAll);
		rmAddObjectDefConstraint(silver2ID, Southward);
				
		if (cNumberNonGaiaPlayers <=2)
	{	
	    rmPlaceObjectDefAtLoc(silver2ID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*8.0);  
    } 
	    else
	{	
	    rmPlaceObjectDefAtLoc(silver2ID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*4.0);
    } 	
	
/*===============================================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
    rmSetStatusText("",0.80);
/*===============================================================================================================================================*/
// ***************************************************** DEFINE AND PLACE THE TREASURES: ******************************************************* //
/*===============================================================================================================================================*/
// NONE FOR NOW:
/*-----------------------------------------------------------------------------------------------------------------------------------------------*/

	    // NUGGET CONSTRAINTS:
	    int avoidNugget=rmCreateTypeDistanceConstraint("the stuff vs nugget", "AbstractNugget", 15.0);
		int avoidMediumNugget=rmCreateTypeDistanceConstraint("The medium vs nugget", "AbstractNugget", 25.0);
	    int avoidFarNugget=rmCreateTypeDistanceConstraint("the far vs nugget", "AbstractNugget", 85.0);
        	
/*-----------------------------------------------------------------------------------------------------------------------------------------------*/		
		
		// THE NORTHERN EASY NUGGETS:
	    int nuggetID= rmCreateObjectDef("The Northern Easy Nugget"); 
	    rmAddObjectDefItem(nuggetID, "Nugget", 1, 0.0);
		rmSetNuggetDifficulty(1, 3);
	    rmSetObjectDefMinDistance(nuggetID, 0.0);
	    rmSetObjectDefMaxDistance(nuggetID, rmXFractionToMeters(0.5));
	    
		rmAddObjectDefConstraint(nuggetID, avoidFarNugget);
		rmAddObjectDefConstraint(nuggetID, forestConstraint);
		rmAddObjectDefConstraint(nuggetID, silverConstraint);
		rmAddObjectDefConstraint(nuggetID, nativesConstraint);
        rmAddObjectDefConstraint(nuggetID, playerConstraint);
		rmAddObjectDefConstraint(nuggetID, playerEdgeConstraint);
		rmAddObjectDefConstraint(nuggetID, Northward);
		rmAddObjectDefConstraint(nuggetID, avoidImpassableLand);
		rmAddObjectDefConstraint(nuggetID, cliffConstraint);
		rmAddObjectDefConstraint(nuggetID, lakeConstraint);
		rmAddObjectDefConstraint(nuggetID, avoidAll);
	
		if (cNumberNonGaiaPlayers <=2)
	{	
		rmPlaceObjectDefAtLoc(nuggetID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*5.0);
	}
        else
	{
        rmPlaceObjectDefAtLoc(nuggetID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*2.5);
	}

/*----------------------------------------------------------------------------------------------------------------*/

        // THE SOUTHERN EASY NUGGETS:
	    int nugget2ID= rmCreateObjectDef("The Southern Easy Nugget"); 
	    rmAddObjectDefItem(nugget2ID, "Nugget", 1, 0.0);
		rmSetNuggetDifficulty(1, 3);
	    rmSetObjectDefMinDistance(nugget2ID, 0.0);
	    rmSetObjectDefMaxDistance(nugget2ID, rmXFractionToMeters(0.5));

		rmAddObjectDefConstraint(nugget2ID, avoidFarNugget);
		rmAddObjectDefConstraint(nugget2ID, forestConstraint);
		rmAddObjectDefConstraint(nugget2ID, silverConstraint);
		rmAddObjectDefConstraint(nugget2ID, nativesConstraint);
        rmAddObjectDefConstraint(nugget2ID, playerConstraint);
		rmAddObjectDefConstraint(nugget2ID, playerEdgeConstraint);
		rmAddObjectDefConstraint(nugget2ID, Southward);
		rmAddObjectDefConstraint(nugget2ID, avoidImpassableLand);
		rmAddObjectDefConstraint(nugget2ID, cliffConstraint);
		rmAddObjectDefConstraint(nugget2ID, lakeConstraint);
		rmAddObjectDefConstraint(nugget2ID, avoidAll);
		   
		if (cNumberNonGaiaPlayers <=2)
	{	
		rmPlaceObjectDefAtLoc(nugget2ID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*5.0);
	}
        else
	{
        rmPlaceObjectDefAtLoc(nugget2ID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*2.5);
	}
	
/*===============================================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
    rmSetStatusText("",0.85);
/*===============================================================================================================================================*/
/*===============================================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
    rmSetStatusText("",0.80);
/*===============================================================================================================================================*/
// *************************************************** DEFINE AND PLACE THE HUNTABLE HERDS: **************************************************** //
/*===============================================================================================================================================*/

        // CREATE THE HUNTABLE HERDS CONSTRAINTS:
	    int huntableConstraint=rmCreateTypeDistanceConstraint("stuff vs huntable", "ypSerow", 15.0);
		int huntableMediumConstraint=rmCreateTypeDistanceConstraint("medium vs huntable", "ypSerow", 25.0);
	    int huntableFarConstraint=rmCreateTypeDistanceConstraint("far vs huntable", "ypSerow", 85.0);
	
/*-----------------------------------------------------------------------------------------------------------------------------------------------*/		
	
		// THE NORTHERN HUNTABLE HERDS:
	
		int huntableID=rmCreateObjectDef("The Northern Huntable Herds");
	    
		int bonusChance=rmRandFloat(0, 1);
	    if(bonusChance<0.5)   
		rmAddObjectDefItem(huntableID, "ypSerow", rmRandInt(4,6), 6.0);
	    else
		rmAddObjectDefItem(huntableID, "ypSerow", rmRandInt(8,10), 8.0);
	    
		rmSetObjectDefMinDistance(huntableID, 0.0);
	    rmSetObjectDefMaxDistance(huntableID, rmXFractionToMeters(0.5));
	    
		rmAddObjectDefConstraint(huntableID, huntableFarConstraint);
		rmAddObjectDefConstraint(huntableID, silverConstraint);
		rmAddObjectDefConstraint(huntableID, nuggetConstraint);
		rmAddObjectDefConstraint(huntableID, forestConstraint);
		rmAddObjectDefConstraint(huntableID, nativesConstraint);
		rmAddObjectDefConstraint(huntableID, Northward);
		rmAddObjectDefConstraint(huntableID, playerConstraint);
		rmAddObjectDefConstraint(huntableID, avoidImpassableLand);
		rmAddObjectDefConstraint(huntableID, playerEdgeConstraint);
		rmAddObjectDefConstraint(huntableID, avoidAll);
		rmAddObjectDefConstraint(huntableID, cliffConstraint);
		rmAddObjectDefConstraint(huntableID, lakeConstraint);
	
		if (cNumberNonGaiaPlayers <=2)
	{	
	    rmPlaceObjectDefAtLoc(huntableID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*5.0);  
    } 
	    else
	{	
	    rmPlaceObjectDefAtLoc(huntableID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*2.5);
    }	
	
/*-----------------------------------------------------------------------------------------------------------------------------------------------*/
        
		// THE SOUTHERN HUNTABLE HERDS:
	
		int huntable2ID=rmCreateObjectDef("The Southern Huntable Herds");
	    
		bonusChance=rmRandFloat(0, 1);
	    if(bonusChance<0.5)   
		rmAddObjectDefItem(huntable2ID, "ypSerow", rmRandInt(4,6), 6.0);
	    else
		rmAddObjectDefItem(huntable2ID, "ypSerow", rmRandInt(8,10), 8.0);
	    
		rmSetObjectDefMinDistance(huntable2ID, 0.0);
	    rmSetObjectDefMaxDistance(huntable2ID, rmXFractionToMeters(0.5));
	    
		rmAddObjectDefConstraint(huntable2ID, huntableFarConstraint);
		rmAddObjectDefConstraint(huntable2ID, silverConstraint);
		rmAddObjectDefConstraint(huntable2ID, nuggetConstraint);
		rmAddObjectDefConstraint(huntable2ID, forestConstraint);
		rmAddObjectDefConstraint(huntable2ID, nativesConstraint);
		rmAddObjectDefConstraint(huntable2ID, Southward);
		rmAddObjectDefConstraint(huntable2ID, playerConstraint);
		rmAddObjectDefConstraint(huntable2ID, avoidImpassableLand);
		rmAddObjectDefConstraint(huntable2ID, playerEdgeConstraint);
		rmAddObjectDefConstraint(huntable2ID, avoidAll);
		rmAddObjectDefConstraint(huntable2ID, cliffConstraint);
		rmAddObjectDefConstraint(huntable2ID, lakeConstraint);
		
		if (cNumberNonGaiaPlayers <=2)
	{	
	    rmPlaceObjectDefAtLoc(huntable2ID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*5.0);  
    } 
	    else
	{	
	    rmPlaceObjectDefAtLoc(huntable2ID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*2.5);
    }
	
/*===============================================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
    rmSetStatusText("",0.90);
/*===============================================================================================================================================*/
// ******************************************************** DEFINE AND PLACE THE BERRIES: ****************************************************** //        
/*===============================================================================================================================================*/

		// CREATE THE FRUITS CONSTRAINTS:
	    //int avoidFruits=rmCreateTypeDistanceConstraint("the stuff vs fruits", "AbstractFruit", 15.0);
		//int avoidMediumFruits=rmCreateTypeDistanceConstraint("the medium vs fruits", "AbstractFruit", 40.0);
	    //int avoidFarFruits=rmCreateTypeDistanceConstraint("the far vs fruits", "AbstractFruit", 85.0);
		
/*-----------------------------------------------------------------------------------------------------------------------------------------------*/		
		
		// THE NORTHERN BERRIES:
		int berriesID=rmCreateObjectDef("The Northern Berries");
	    rmAddObjectDefItem(berriesID, "berrybush", rmRandInt(5,8), 5.0); 
	    rmSetObjectDefMinDistance(berriesID, 0.0);
	    rmSetObjectDefMaxDistance(berriesID, rmXFractionToMeters(0.5));
	    
		rmAddObjectDefConstraint(berriesID, fruitsFarConstraint);
	    rmAddObjectDefConstraint(berriesID, huntableConstraint);
		rmAddObjectDefConstraint(berriesID, silverConstraint);
		rmAddObjectDefConstraint(berriesID, nuggetConstraint);
		rmAddObjectDefConstraint(berriesID, forestConstraint);
		rmAddObjectDefConstraint(berriesID, nativesConstraint);
		rmAddObjectDefConstraint(berriesID, playerConstraint);
		rmAddObjectDefConstraint(berriesID, playerEdgeConstraint);
		rmAddObjectDefConstraint(berriesID, avoidImpassableLand);
		rmAddObjectDefConstraint(berriesID, Northward);
		rmAddObjectDefConstraint(berriesID, avoidAll);
		rmAddObjectDefConstraint(berriesID, cliffConstraint);
		rmAddObjectDefConstraint(berriesID, lakeConstraint);
				
		if (cNumberNonGaiaPlayers <=2)
	{	
	    rmPlaceObjectDefAtLoc(berriesID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*5.0);  
    } 
	    else
	{	
	    rmPlaceObjectDefAtLoc(berriesID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*2.5);
    }
	
/*-----------------------------------------------------------------------------------------------------------------------------------------------*/

        // THE SOUTHERN BERRIES:
		int berries2ID=rmCreateObjectDef("The Southern Berries");
	    rmAddObjectDefItem(berries2ID, "berrybush", rmRandInt(5,8), 5.0); 
	    rmSetObjectDefMinDistance(berries2ID, 0.0);
	    rmSetObjectDefMaxDistance(berries2ID, rmXFractionToMeters(0.5));
	    
		rmAddObjectDefConstraint(berries2ID, fruitsFarConstraint);
	    rmAddObjectDefConstraint(berries2ID, huntableConstraint);
		rmAddObjectDefConstraint(berries2ID, silverConstraint);
		rmAddObjectDefConstraint(berries2ID, nuggetConstraint);
		rmAddObjectDefConstraint(berries2ID, forestConstraint);
		rmAddObjectDefConstraint(berries2ID, nativesConstraint);
		rmAddObjectDefConstraint(berries2ID, playerConstraint);
		rmAddObjectDefConstraint(berries2ID, playerEdgeConstraint);
		rmAddObjectDefConstraint(berries2ID, avoidImpassableLand);
		rmAddObjectDefConstraint(berries2ID, Southward);
		rmAddObjectDefConstraint(berries2ID, avoidAll);
		rmAddObjectDefConstraint(berries2ID, cliffConstraint);
		rmAddObjectDefConstraint(berries2ID, lakeConstraint);
		
		if (cNumberNonGaiaPlayers <=2)
	{	
	    rmPlaceObjectDefAtLoc(berries2ID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*4);  
    } 
	    else
	{	
	    rmPlaceObjectDefAtLoc(berries2ID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*2);
    }

/*===============================================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
    rmSetStatusText("",0.925);
/*===============================================================================================================================================*/
// *************************************************** DEFINE AND PLACE THE HERDABLE HERDS: **************************************************** //
/*===============================================================================================================================================*/

        // THE HERDABLE HERDS CONSTRAINTS:
	    int herdableConstraint=rmCreateTypeDistanceConstraint("stuff vs herdable", "ypWaterBuffalo", 15.0);
		int herdableMediumConstraint=rmCreateTypeDistanceConstraint("medium vs herdable", "ypWaterBuffalo", 25.0);
	    int herdableFarConstraint=rmCreateTypeDistanceConstraint("far vs herdable", "ypWaterBuffalo", 85.0);
	
/*-----------------------------------------------------------------------------------------------------------------------------------------------*/		
	
		// THE NORTHERN HERDABLE HERDS:
	
		int herdableID=rmCreateObjectDef("The Northern herdable Herds");
	    
		bonusChance=rmRandFloat(0, 1);
	    if(bonusChance<0.5)   
		rmAddObjectDefItem(herdableID, "ypWaterBuffalo", rmRandInt(4,6), 5.0);
	    else
		rmAddObjectDefItem(herdableID, "ypWaterBuffalo", rmRandInt(8,10), 7.0);
	    
		rmSetObjectDefMinDistance(herdableID, 0.0);
	    rmSetObjectDefMaxDistance(herdableID, rmXFractionToMeters(0.5));
	    
		rmAddObjectDefConstraint(herdableID, herdableFarConstraint);
		rmAddObjectDefConstraint(herdableID, fruitsConstraint);
	    rmAddObjectDefConstraint(herdableID, huntableMediumConstraint);
		rmAddObjectDefConstraint(herdableID, silverConstraint);
		rmAddObjectDefConstraint(herdableID, nuggetConstraint);
		rmAddObjectDefConstraint(herdableID, forestConstraint);
		rmAddObjectDefConstraint(herdableID, nativesConstraint);
		rmAddObjectDefConstraint(herdableID, Northward);
		rmAddObjectDefConstraint(herdableID, playerConstraint);
		rmAddObjectDefConstraint(herdableID, avoidImpassableLand);
		rmAddObjectDefConstraint(herdableID, playerEdgeConstraint);
		rmAddObjectDefConstraint(herdableID, avoidAll);
		rmAddObjectDefConstraint(herdableID, cliffConstraint);
		rmAddObjectDefConstraint(herdableID, lakeConstraint);

		if (cNumberNonGaiaPlayers <=2)
	{	
	    rmPlaceObjectDefAtLoc(herdableID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*5.0);  
    } 
	    else
	{	
	    rmPlaceObjectDefAtLoc(herdableID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*2.5);
    }
	
/*-----------------------------------------------------------------------------------------------------------------------------------------------*/	
	
		// THE SOUTHERN HERDABLE HERDS:
	
		int herdable2ID=rmCreateObjectDef("The Southern herdable Herds");
	    
		bonusChance=rmRandFloat(0, 1);
	    if(bonusChance<0.5)   
		rmAddObjectDefItem(herdable2ID, "ypWaterBuffalo", rmRandInt(4,6), 5.0);
	    else
		rmAddObjectDefItem(herdable2ID, "ypWaterBuffalo", rmRandInt(8,10), 7.0);
	    
		rmSetObjectDefMinDistance(herdable2ID, 0.0);
	    rmSetObjectDefMaxDistance(herdable2ID, rmXFractionToMeters(0.5));
	    
		rmAddObjectDefConstraint(herdable2ID, herdableFarConstraint);
		rmAddObjectDefConstraint(herdable2ID, fruitsConstraint);
	    rmAddObjectDefConstraint(herdable2ID, huntableMediumConstraint);
		rmAddObjectDefConstraint(herdable2ID, silverConstraint);
		rmAddObjectDefConstraint(herdable2ID, nuggetConstraint);
		rmAddObjectDefConstraint(herdable2ID, forestConstraint);
		rmAddObjectDefConstraint(herdable2ID, nativesConstraint);
		rmAddObjectDefConstraint(herdable2ID, Southward);
		rmAddObjectDefConstraint(herdable2ID, playerConstraint);
		rmAddObjectDefConstraint(herdable2ID, avoidImpassableLand);
		rmAddObjectDefConstraint(herdable2ID, playerEdgeConstraint);
		rmAddObjectDefConstraint(herdable2ID, avoidAll);
		rmAddObjectDefConstraint(herdable2ID, cliffConstraint);
		rmAddObjectDefConstraint(herdable2ID, lakeConstraint);
	
		if (cNumberNonGaiaPlayers <=2)
	{	
	    rmPlaceObjectDefAtLoc(herdable2ID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*5.0);  
    } 
	    else
	{	
	    rmPlaceObjectDefAtLoc(herdable2ID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*2.5);
    }
	
/*===============================================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
    rmSetStatusText("",0.95);
/*===============================================================================================================================================*/
// ****************************************************** DEFINE AND PLACE SOME FISHES: ******************************************************** //
/*===============================================================================================================================================*/

        int fishVsFishID=rmCreateTypeDistanceConstraint("fish v fish", "AbstractFish", 18.0);
        int fishLand = rmCreateTerrainDistanceConstraint("fish land", "land", true, 8.0);
        int fishVsWhale=rmCreateTypeDistanceConstraint("fish vs whale", "AbstractWhale", 10.0);		
		
/*-----------------------------------------------------------------------------------------------------------------------------------------------*/		
	   
	    // THE NORTHERN FISHSALMON:
		int fishID=rmCreateObjectDef("The Northern Fish");
        rmAddObjectDefItem(fishID, "ypFishCatfish", 1, 3.0);
        rmSetObjectDefMinDistance(fishID, 0.0);
        rmSetObjectDefMaxDistance(fishID, rmXFractionToMeters(0.5));
        rmAddObjectDefConstraint(fishID, fishVsFishID);
        rmAddObjectDefConstraint(fishID, fishLand);
		//rmAddObjectDefConstraint(fishID, Northward);
		
		if (cNumberNonGaiaPlayers <=2)
        rmPlaceObjectDefAtLoc(fishID, 0, 0.5, 0.5, 30*cNumberNonGaiaPlayers);
		else
		rmPlaceObjectDefAtLoc(fishID, 0, 0.5, 0.5, 15*cNumberNonGaiaPlayers);

/*===============================================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
    rmSetStatusText("",0.965);
/*===============================================================================================================================================*/
// ******************************************************* CHECK FOR THE KOTH GAME MODE: ******************************************************* //
/*===============================================================================================================================================*/
// NONE FOR NOW:
/*-----------------------------------------------------------------------------------------------------------------------------------------------*/
	
    	int avoidKOTH=rmCreateTypeDistanceConstraint("avoid KOTH", "ypKingsHill", 12.0);
	
/*-----------------------------------------------------------------------------------------------------------------------------------------------*/		
		
		if(rmGetIsKOTH()) 
	{
        int randLoc = rmRandInt(1,2);
        float xLoc = 0.65;
        float yLoc = 0.65;
        float walk = 0.05;
		
		if(randLoc == 1)
        yLoc = .70;
    
        else
        yLoc = .30;
    
        ypKingsHillPlacer(xLoc, xLoc, walk, avoidImpassableLand);
		//ypKingsHillPlacer(xLoc, yLoc, walk, 0);
		rmEchoInfo("XLOC = "+xLoc);
        rmEchoInfo("XLOC = "+yLoc);
    }
  
/*===============================================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
    rmSetStatusText("",0.975);
/*===============================================================================================================================================*/	
// ************************************************************ STARTER SHIPMENT TRIGGERS: ***************************************************** //
/*===============================================================================================================================================*/
		
		// THE STARTER SHIPMENT TRIGGERS:
		for(i = 1; < cNumberPlayers) 
  {
        rmCreateTrigger("XP"+i);
        rmSwitchToTrigger(rmTriggerID("XP"+i));
        rmSetTriggerPriority(3); 
        rmSetTriggerActive(true);
        rmSetTriggerRunImmediately(true);
        rmSetTriggerLoop(false);
      
        rmAddTriggerCondition("Always");
    
        rmAddTriggerEffect("Grant Resources");
        rmSetTriggerEffectParamInt("PlayerID", i, false);
        rmSetTriggerEffectParam("ResName", "XP", false);
        rmSetTriggerEffectParam("Amount", "275", false);
  }	
  
/*===============================================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",1.00);
/*===============================================================================================================================================*/
}
/*===============================================================================================================================================*/
// **************************************************** THIS IS THE END OF THE MAP: ************************************************************ //
/*===============================================================================================================================================*/




